<?php

use Illuminate\Database\Capsule\Manager as Capsule;
use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;

class CreateVerificationCodesTable extends Migration {

  /**
   * Run the migrations.
   *
   * @return void
   */
  public function up()
  {
    Capsule::schema()->create($this->getTableName(), function(Blueprint $table)
    {
      $table->increments('id');
      $table->string('contact');
      $table->string('code', 255);
      $table->unsignedInteger('attempts')->default(0);
      $table->string('verification_strategy_type', 255);
      $table->text('data');
      $table->dateTime('expires_at');
      $table->softDeletes();
      $table->timestamps();
    });
  }

  /**
   * Reverse the migrations.
   *
   * @return void
   */
  public function down()
  {
    Capsule::schema()->dropIfExists($this->getTableName());
  }
  
  /**
   * Get the table name from the config file
   *
   * @return string the table name
   */
  private function getTableName() {
    return config('authentication.table_names.verification_codes', 'verification_codes');
  }
}


