<?php

use GuzzleHttp\Client;

trait InteractsWithMailcatcher {

  protected static $mailcatcherGuzzleClient;

  public static function deleteAllMailcatcherEmails() {
    $response = self::$mailcatcherGuzzleClient->delete('/messages', [
      'headers' => [
        'Accept' => 'application/json'
      ]
    ]);

    if (!$response->getStatusCode() === 200) {
      throw new RuntimeException("Call to delete mailcatcher emails failed!");
    }
  }

  public static function getAllMailcatcherEmails() {
    $response = self::$mailcatcherGuzzleClient->get('/messages', [
      'headers' => [
        'Accept' => 'application/json'
      ]
    ]);

    if (!$response->getStatusCode() === 200) {
      throw new RuntimeException("Call to get all mailcatcher emails failed!");
    }

    return $response->json();
  }

  public static function getMailcatcherEmail($id) {
    $response = self::$mailcatcherGuzzleClient->get('/messages/'. $id . '.json', [
      'headers' => [
        'Accept' => 'application/json'
      ]
    ]);

    if (!$response->getStatusCode() === 200) {
      throw new RuntimeException("Call to get mailcatcher email with id '$id' failed!");
    }

    return $response->json();
  }
}
