<?php

namespace spec\Myriad\Authentication\Http\Controllers;

use PhpSpec\ObjectBehavior;
use Prophecy\Argument;
use Illuminate\Contracts\Bus\Dispatcher;
use Illuminate\Http\Request;
use Myriad\Installations\InstallationManager;
use Myriad\Installations\Models\Installation;
use Myriad\Authentication\Lib\Jobs\LoginWithEmailFromInstallation;

class LoginControllerSpec extends ObjectBehavior
{
  public function it_is_initializable()
  {
    $this->shouldHaveType('Myriad\Authentication\Http\Controllers\LoginController');
  }

  public function it_should_dispatch_login_command(
    Request $request,
    InstallationManager $manager,
    Installation $installation,
    Dispatcher $dispatcher
  ) {
    $data = ['email' => 'somebody@somewhere.com', 'password' => '12345'];
    $request->all()->willReturn($data);

    $manager->getInstallation()->willReturn($installation);
    $installation->uuid = '984e7457b1b044589c98ed9552de3c15';

    $response = [
      'access_token' => 'f8235077dc1147dcaefe89f7ce5a76a8',
      'expires_at' => '2016-05-06T19:43:14.677Z'
    ];

    $dispatcher->dispatchNow(Argument::type(LoginWithEmailFromInstallation::class))
      ->willReturn($response);

    $result = $this->login($request, $manager, $dispatcher);

    $result['data']->shouldEqual($response);
  }
}
