<?php

namespace spec\Myriad\Authentication\Lib\Strategies;

use PhpSpec\ObjectBehavior;
use Prophecy\Argument;
use Myriad\Authentication\Lib\Repositories\IUserRepository;
use Illuminate\Contracts\Config\Repository as Config;
use Illuminate\Contracts\Mail\Mailer;

class EmailVerificationSpec extends ObjectBehavior
{
  function let(
    IUserRepository $userRepo,
    Mailer $mailer,
    Config $config
  ) {
    $this->beConstructedWith($userRepo, $mailer, $config);
  }
  function it_is_initializable()
  {
    $this->shouldHaveType('\Myriad\Authentication\Lib\Strategies\EmailVerification');
  }

  function it_should_implement_verification_strategy_interface()
  {
    $this->shouldImplement(\Myriad\Authentication\Lib\Strategies\IVerificationStrategy::class);
  }

  function it_should_implement_confirmation_email_sender_interface()
  {
    $this->shouldImplement(\Myriad\Authentication\Lib\Services\IEmailConfirmer::class);
  }

}
