<?php

namespace Myriad\Authentication\Http\Controllers;

use Illuminate\Http\Request;
use Myriad\Installations\InstallationManager;
use Illuminate\Contracts\Bus\Dispatcher;
use Myriad\Authentication\Lib\Jobs\LoginWithEmailFromInstallation;
use Illuminate\Routing\Controller;

class LoginController extends Controller
{
  public function login(
    Request $request,
    InstallationManager $manager,
    Dispatcher $dispatcher
  ) {
    $installation = $manager->getInstallation();

    $arguments = array_merge($request->all(), ['installation_uuid' => $installation->uuid]);
    $command = new LoginWithEmailFromInstallation($arguments);

    $response = $dispatcher->dispatchNow($command);

    return [
      'data' => $response
    ];
  }
}
