<?php

namespace Myriad\Authentication\Http\Transformers;

use League\Fractal\TransformerAbstract;
use Myriad\Authentication\Models\UserEmail;

class UserEmailTransformer extends TransformerAbstract {

  public function transform(UserEmail $userEmail) {
    return [
      'id' => $userEmail->id,
      'user_id' => $userEmail->user_id,
      'email' => $userEmail->email,
      'type' => $userEmail->type,
      'primary' => (boolean) $userEmail->primary,
      'verified' => (boolean) $userEmail->verified,
      'created_at' => $userEmail->created_at->toIso8601String(),
      'updated_at' => $userEmail->updated_at->toIso8601String()
    ];
  }

}

