<?php

namespace Myriad\Authentication\Lib\Repositories;

use Myriad\Authentication\Lib\Repositories\IVerificationCodeRepository;
use Myriad\Authentication\Models\VerificationCode;
use Carbon\Carbon;
use Illuminate\Contracts\Auth\Authenticatable;

class EloquentVerificationCodeRepository implements IVerificationCodeRepository
{

  public function findVerificationCodes($contact, $includeExpired = false, $maxAttemptCount = 5) {
    $query = VerificationCode::where('contact', trim($contact));

    if (!$includeExpired) {
      $query = $query->where('expires_at', '>=', Carbon::now());
    }

    if ($maxAttemptCount) {
      $query = $query->where('attempts', '<', $maxAttemptCount);
    }

    return $query->get();
  }

}
