<?php

namespace Myriad\Authentication\Lib\Strategies;

use Carbon\Carbon;
use Myriad\Authentication\Models\VerificationCode;

trait CreatesVerificationCodes {
  use GeneratesCodes;

  protected $config;

  public function createVerificationCode(
    $contact,
    $strategyType,
    $customData
  ) {
    $expirationMinutes = $this->config->get('authentication.verification_code_expiration_minutes');
    $expiration = Carbon::now()->addMinutes($expirationMinutes);

    $verificationCode = VerificationCode::create([
      'contact' => $contact,
      'code' => $this->generateCode(4),
      'verification_strategy_type' => $strategyType,
      'data' => json_encode($customData),
      'expires_at' => $expiration
    ]);

    return $verificationCode;
  }
}
